import getopt, math, random, sys, time, types, wx, subprocess, os

from multiprocessing import Process, Queue, cpu_count, current_process, freeze_support
from Queue import Empty

import shutil

class LeftPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        self.nameBox = wx.TextEntryDialog(None, 'Enter file name to upload', 'InputBox', '')
        
        
        if self.nameBox.ShowModal()==wx.ID_OK:
            inpnmbr = self.nameBox.GetValue()
        
        
        chooseGnBox = wx.SingleChoiceDialog(None, 'Select the gene option', 'Gene Options', ['All','wzm','wzt'])
        
        if chooseGnBox.ShowModal() == wx.ID_OK:
            gnnm = chooseGnBox.GetStringSelection()
        
        chooseOneBox = wx.SingleChoiceDialog(None, 'Select the alignment option', 'Alignment Options', ['NN','PP','NP'])
        
        if chooseOneBox.ShowModal() == wx.ID_OK:
            algnmnt = chooseOneBox.GetStringSelection()

        
        first = subprocess.Popen(['/bin/echo', inpnmbr, gnnm, algnmnt], stdout=subprocess.PIPE)
        second = subprocess.Popen(['bash', 'o_antgn_testkaptive.sh', inpnmbr, gnnm, algnmnt], stdin=first.stdout)
        
        # Set some program flags
        self.keepgoing = True
        self.i = 0
        self.j = 0
        
        self.my_text = wx.TextCtrl(self, style=wx.TE_MULTILINE)
        btn = wx.Button(self, label='Open Text File')
        btn.Bind(wx.EVT_BUTTON, self.onOpen)

        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(self.my_text, 1, wx.ALL|wx.EXPAND)
        sizer.Add(btn, 0, wx.ALL|wx.CENTER, 5)

        self.SetSizer(sizer)

    def onOpen(self, event):
        wildcard = "TXT files (*.txt)|*.txt"
        dialog = wx.FileDialog(self, "Open Text Files", wildcard=wildcard,
                               style=wx.FD_OPEN | wx.FD_FILE_MUST_EXIST)

        if dialog.ShowModal() == wx.ID_CANCEL:
            return

        path = dialog.GetPath()

        if os.path.exists(path):
            with open(path) as fobj:
                for line in fobj:
                    self.my_text.WriteText(line)
        
    def Quit(self, e):
        self.Close()

    def popup(self, event):
        pop = NewFrame()

    def OnMove(self, e): 
      x, y = e.GetPosition() 
      print ("current window position x = ",x," y= ",y)

class MainPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        hsizer = wx.BoxSizer(wx.HORIZONTAL)
        v_sizer = wx.BoxSizer(wx.VERTICAL)

        left_panel = LeftPanel(self)
        hsizer.Add(left_panel,1,wx.EXPAND)

        self.done_btn = wx.Button(self, -1, "DONE")
        self.Bind(wx.EVT_BUTTON, self.OnDone, self.done_btn)

        v_sizer.Add(hsizer, 1, wx.EXPAND)
        v_sizer.Add(self.done_btn,0, wx.ALL |wx.CENTER, 3)

        self.SetSizer(v_sizer)

    def OnDone(self,event):
        self.Close()
        self.Parent.Destroy()

class OFrame(wx.Frame):
    def __init__(self):
        wx.Frame.__init__(self, None, title="O-antigen Prediction")
        panel = MainPanel(self)
        self.SetWindowStyle(wx.STAY_ON_TOP)
        self.Show()
