#!/bin/bash
rm -rf sult_*
rm -rf serout_*
rm -rf wz*.txt
rm -rf wbap.txt
rm -rf wcaj.txt
rm -rf sertp_*
rm -rf resulvt*.txt
rm -rf newfas.fasta

valb=$2 #Query Gene type
valc=$3 #Alignment type
scnt=1 #Number of coding regions (How many ">" are there)

ncnmm=$1 #Input fasta file
cp $ncnmm newfas.fasta
ncnm=`echo $ncnmm | cut -d "." -f1 | rev | cut -d"/" -f1  | rev`
kppath=`echo $ncnmm | cut -d "." -f1 | rev | cut -d"/" -f2-  | rev`
kpath=$kppath"/"

#formatdb -p F -i kantgn_gn.fsa
#above command is absolete for the latest version of blast+ and following command replaces that
makeblastdb -in kantgn_gn.fsa -dbtype nucl
blastn -query newfas.fasta -db kantgn_gn.fsa -outfmt 6 > output.out

if [ -s "output.out" ]; then
    while read -r line || [[ -n $line ]]; do
	a=`echo $line |awk '{print $1}'`
	b=`echo $line |awk '{print $2}'`
	c=`echo $line |awk '{print $3}'`
	d=`echo $line |awk '{print $4}'`
	e=`echo $line |awk '{print $5}'`
	f=`echo $line |awk '{print $6}'`
	g=`echo $line |awk '{print $7}'`
	h=`echo $line |awk '{print $8}'`
	i=`echo $line |awk '{print $9}'`
	j=`echo $line |awk '{print $10}'`
	k=`echo $line |awk '{print $11}'`
	l=`echo $line |awk '{print $12}'`
	m=`echo $line |awk '{printf "%3i", $3}'`
	if [ $m -ge 95 ] && [ $d -ge 200 ]; then
	    p=`echo $b | cut -d "|" -f3 | cut -d ":" -f1`
	    q=`echo $p | cut -d "_" -f2`
	    r=`echo $b | cut -d ":" -f2`
	    s=`echo $b | cut -d "|" -f2`
	    echo -e "$q   - $r   - $c   - $d   - $l - $s" >>resulvt.txt
	else
	    continue;
	fi
    done<output.out
    #gnlnm=`cat resulvt.txt | awk '{print $11}' | sort -k1 -u | wc -l`
    gnlnm=`cat wgene.dat | wc -l`
    
    for ((ek=1; ek<=$gnlnm; ek++))
    do
	gnlname=`cat wgene.dat | head -$ek | tail -1`
	grep -i $gnlname resulvt.txt > resulvt_$ek.txt
	grep -i $gnlname"|" output.out > output_$ek.out
	cat resulvt_$ek.txt |awk '{print $1}' | sort -k1 -u > sult_$ek.txt
	grep -i "100.00" resulvt_$ek.txt > result_hndrd.txt
	#cat result.txt |awk '{print $1}' | sort -k1 -u > result1.txt
	if [ -s "result_hndrd.txt" ];
	then
	    awk '{print $1}' result_hndrd.txt | sort -k1 -u> sult_$ek.txt
	fi
    done
    
    
    grep -i "wzi" resulvt_*.txt | awk '{print $1}' | cut -d ":" -f2 | sort -u > wzi.txt
    grep -i "wza" resulvt_*.txt | awk '{print $1}' | cut -d ":" -f2 | sort -u > wza.txt
    grep -i "wzb" resulvt_*.txt | awk '{print $1}' | cut -d ":" -f2 | sort -u > wzb.txt
    grep -i "wzc" resulvt_*.txt | awk '{print $1}' | cut -d ":" -f2 | sort -u > wzc.txt
    grep -i "wbap" resulvt_*.txt | awk '{print $1}' | cut -d ":" -f2 | sort -u > wbap.txt
    grep -i "wzx" resulvt_*.txt | awk '{print $1}' | cut -d ":" -f2 | sort -u > wzx.txt
    grep -i "wzy" resulvt_*.txt | awk '{print $1}' | cut -d ":" -f2 | sort -u > wzy.txt
    grep -i "wcaj" resulvt_*.txt | awk '{print $1}' | cut -d ":" -f2 | sort -u > wcaj.txt
    
    find w*.txt -size  0 -print0 |xargs -0 rm --
    
    chmod 777 sult*.txt
    find sult*.txt -size  0 -print0 |xargs -0 rm --
    #bash link2.sh | tail -n +3 | head -n -1 | awk '{print $3}' | tr '[:upper:]' '[:lower:]' > new_combine.txt
    bash link2.sh | grep -i "sult" | awk '{print $3}' | tr '[:upper:]' '[:lower:]' > new_combine.txt
    cp new_combine.txt new_combine_pre.txt
    sultn=`ls sult*.txt | wc -l`
    echo "# of sult files: $sultn"
    
    serchtn=`bash link2.sh | grep -i "sult" | awk '{print $3}' | tail -1 | tr '[:upper:]' '[:lower:]'`
    chtn=`cat new_combine.txt | wc -l`
    
    if [ $chtn -gt 1 ]
    then
	for (( ng=1; ng<=$chtn; ng=$ng+1 ))
	do
	    sergn=`cat new_combine_pre.txt | head -$ng | tail -1`
	    nkantg=`grep -i $sergn sult*.txt | cut -d ":" -f1 | sort -u | wc -l`
	    
	    if [ $nkantg -ge 3 ]
	    then
		if [ "$sergn" == "k33" ] || [ "$sergn" == "k40" ]
		then
		    rm wzi.txt
		elif [ "$sergn" == "k34" ]
		then
		    rm wzx.txt
		elif [ "$sergn" == "k50" ]
		then
		    rm wzb.txt wzc.txt wzx.txt wzy.txt
		elif [ "$sergn" == "k29" ] || [ "$sergn" == "k71" ] || [ "$sergn" == "kl108" ] || [ "$sergn" == "kl109" ]
		then
		    rm wzy.txt
		elif [ "$sergn" == "kl110" ] || [ "$sergn" == "kl113" ] || [ "$sergn" == "kl116" ] || [ "$sergn" == "kl118" ]
		then
		    rm wzy.txt
		fi
	    fi
	    
	    nsergn=`bash link2.sh | grep -i "sult" | grep -i $sergn | awk '{print $1}' | head -$ng | tail -1 | awk -F'/' '{ print NF }'`
	    	
	    if [ $nsergn -eq 7 ]
	    then
		echo $sergn > new_combine.txt
		
	    elif [ $nsergn -lt 7 ] && [ $nsergn -ge 4 ]
	    then
		zx=`ls sult*.txt | wc -l`
		if [ $nsergn -eq $zx ]
		then
		    if [ $sergn == $serchtn ]
		    then
			echo $sergn > new_combine.txt
		    else
			echo $sergn > new_combine.txt
		    fi
		else
		    if [ $sergn == $serchtn ]
		    then
			yx=`grep -L $sergn sult*.txt | wc -l`
			
			for (( nyx=1; nyx<=$yx; nyx=$nyx+1 ))
			do
			    xx=`grep -L $sergn sult*.txt | head -$nyx | tail -1 | cut -d "_" -f2 | cut -d "." -f1`
			    grep -i $sergn":" output_$xx.out | awk '$3 >= 90.0' > serout_$xx.out
			    
			    cp sult_$xx.txt old_sult_$xx.txt
			    rm sult_$xx.txt
			    
			    if [ -s "serout_$xx.out" ]
			    then
				while read -r line || [[ -n $line ]]; do
				    a=`echo $line |awk '{print $1}'`
				    b=`echo $line |awk '{print $2}'`
				    c=`echo $line |awk '{print $3}'`
				    d=`echo $line |awk '{print $4}'`
				    e=`echo $line |awk '{print $5}'`
				    f=`echo $line |awk '{print $6}'`
				    g=`echo $line |awk '{print $7}'`
				    h=`echo $line |awk '{print $8}'`
				    i=`echo $line |awk '{print $9}'`
				    j=`echo $line |awk '{print $10}'`
				    k=`echo $line |awk '{print $11}'`
				    l=`echo $line |awk '{print $12}'`
				    m=`echo $line |awk '{printf "%3i", $3}'`
				    
				    if [ $m -ge 90 ] && [ $d -ge 200 ]; then
					p=`echo $b | cut -d "|" -f3 | cut -d ":" -f1`
					q=`echo $p | cut -d "_" -f2`
					r=`echo $b |cut -d "|" -f4`
					if [[ -z "$r" ]]
					then
					    r=`echo $b | cut -d ":" -f2`
					fi
					s=`echo $b |cut -d "|" -f2`
					echo -e "$q   - $r   - $c   - $d   - $l - $s">>resulvt_$xx.txt
					if [ $m -ge 90 ]
					then
					    echo -e "$q" >> sertp_$xx.txt
					fi
				    else
					continue;
				    fi
				done<serout_$xx.out
				cat sertp_$xx.txt |awk '{print $1}' | sort -k1 -u >> sult_$xx.txt
				fln=`cat resulvt_$xx.txt |awk '{print $1}' | sort -k1 -u | tr '[:upper:]' '[:lower:]'`
				cat sertp_$xx.txt |awk '{print $1}' | sort -k1 -u >> $fln.txt
				echo $sergn > new_combine.txt
			    else
				echo $sergn_"variant" > new_combine.txt
			    fi
			done
		    else
			yx=`grep -L $sergn sult*.txt | wc -l`
			
			for (( nyx=1; nyx<=$yx; nyx=$nyx+1 ))
			do
			    xx=`grep -L $sergn sult*.txt | head -$nyx | tail -1 | cut -d "_" -f2 | cut -d "." -f1`
			    grep -i $sergn":" output_$xx.out | awk '$3 >= 90.0' > serout_$xx.out
			
			    if [ -s "serout_$xx.out" ]
			    then
				while read -r line || [[ -n $line ]]; do
				    a=`echo $line |awk '{print $1}'`
				    b=`echo $line |awk '{print $2}'`
				    c=`echo $line |awk '{print $3}'`
				    d=`echo $line |awk '{print $4}'`
				    e=`echo $line |awk '{print $5}'`
				    f=`echo $line |awk '{print $6}'`
				    g=`echo $line |awk '{print $7}'`
				    h=`echo $line |awk '{print $8}'`
				    i=`echo $line |awk '{print $9}'`
				    j=`echo $line |awk '{print $10}'`
				    k=`echo $line |awk '{print $11}'`
				    l=`echo $line |awk '{print $12}'`
				    m=`echo $line |awk '{printf "%3i", $3}'`
				    
				    if [ $m -ge 90 ] && [ $d -ge 200 ]; then
					p=`echo $b | cut -d "|" -f3 | cut -d ":" -f1`
					q=`echo $p | cut -d "_" -f2`
					r=`echo $b |cut -d "|" -f4`
					if [[ -z "$r" ]]
					then
					    r=`echo $b | cut -d ":" -f2`
					fi
					s=`echo $b |cut -d "|" -f2`
					echo -e "$q   - $r   - $c   - $d   - $l - $s">>resulvt_$xx.txt
					if [ $m -ge 90 ]
					then
					    echo -e "$q" >> sertp_$xx.txt
					fi
				    else
					continue;
				    fi
				done<serout_$xx.out
				cat sertp_$xx.txt |awk '{print $1}' | sort -k1 -u >> sult_$xx.txt
				fln=`cat resulvt_$xx.txt |awk '{print $1}' | sort -k1 -u | tr '[:upper:]' '[:lower:]'`
				cat resulvt_$xx.txt |awk '{print $1}' | sort -k1 -u >> $fln.txt
				echo $sergn >> new_combine.txt
			    else
				continue
			    fi
			    
			done
		    fi    
		fi
	    else
		echo "New_Serotype" > new_combine.txt
	    fi
	done
    elif [ $chtn -eq 1 ]
    then
	
	if [ "$serchtn" == "k33" ] || [ "$serchtn" == "k40" ]
	then
	    rm wzi.txt
	elif [ "$serchtn" == "k34" ]
	then
	    rm wzx.txt
	elif [ "$serchtn" == "k50" ]
	then
	    rm wzb.txt wzc.txt wzx.txt wzy.txt
	elif [ "$serchtn" == "k29" ] || [ "$serchtn" == "k71" ] || [ "$serchtn" == "kl108" ] || [ "$serchtn" == "kl109" ]
	then
	    rm wzy.txt
	elif [ "$serchtn" == "kl110" ] || [ "$serchtn" == "kl113" ] || [ "$serchtn" == "kl116" ] || [ "$serchtn" == "kl118" ]
	then
	    rm wzy.txt
	fi
	
	sergn=$serchtn
	nsergn=`bash link2.sh | grep -i "sult" | grep -i $sergn | awk '{print $1}' | awk -F'/' '{ print NF }'`
	sltcnt=`ls sult*.txt | wc -l`
	w_cnt=`ls w*.txt | wc -l`
	ls sult*.txt
	ls w*.txt
        echo "You are with me and sergn is $sergn"

	if [ $nsergn -eq 7 ]
	then
	    echo $sergn > new_combine.txt
	elif [ $nsergn -lt 7 ] && [ $nsergn -ge 4 ]
	then
	    if [ $sltcnt -eq $w_cnt ]
	    then
		echo "entry1"
		echo "sltcnt: $sltcnt"
		echo "w_cnt: $w_cnt"

		zx=`ls sult*.txt | wc -l`
		if [ $nsergn -eq $zx ]
		then
		    echo $sergn > new_combine.txt
		else
		    yx=`grep -L $sergn sult*.txt | wc -l`
		    
		    for (( nyx=1; nyx<=$yx; nyx=$nyx+1 ))
		    do
			xx=`grep -L $sergn sult*.txt | head -$nyx | tail -1 | cut -d "_" -f2 | cut -d "." -f1`
			grep -i $sergn":" output_$xx.out | awk '$3 >= 90.0' > serout_$xx.out
			
		    	cp sult_$xx.txt old_sult_$xx.txt
			rm sult_$xx.txt
			
			if [ -s "serout_$xx.out" ]
			then
			    while read -r line || [[ -n $line ]]; do
				a=`echo $line |awk '{print $1}'`
				b=`echo $line |awk '{print $2}'`
				c=`echo $line |awk '{print $3}'`
				d=`echo $line |awk '{print $4}'`
				e=`echo $line |awk '{print $5}'`
				f=`echo $line |awk '{print $6}'`
				g=`echo $line |awk '{print $7}'`
				h=`echo $line |awk '{print $8}'`
				i=`echo $line |awk '{print $9}'`
				j=`echo $line |awk '{print $10}'`
				k=`echo $line |awk '{print $11}'`
				l=`echo $line |awk '{print $12}'`
				m=`echo $line |awk '{printf "%3i", $3}'`
				
				if [ $m -ge 90 ] && [ $d -ge 200 ]; then
				    p=`echo $b | cut -d "|" -f3 | cut -d ":" -f1`
				    q=`echo $p | cut -d "_" -f2`
				    r=`echo $b |cut -d "|" -f4`
				    if [[ -z "$r" ]]
				    then
					r=`echo $b | cut -d ":" -f2`
				    fi
				    s=`echo $b |cut -d "|" -f2`
				    echo -e "$q   - $r   - $c   - $d   - $l - $s">>resulvt_$xx.txt
				    if [ $m -ge 90 ]
				    then
					echo -e "$q" >> sertp_$xx.txt
				    fi
				else
				    continue;
				fi
			    done<serout_$xx.out
			    cat sertp_$xx.txt |awk '{print $1}' | sort -k1 -u >> sult_$xx.txt
			    fln=`cat resulvt_$xx.txt |awk '{print $1}' | sort -k1 -u | tr '[:upper:]' '[:lower:]'`
			    cat sertp_$xx.txt |awk '{print $1}' | sort -k1 -u >> $fln.txt
			    
			    echo "entry2"
			    echo "sltcnt: $sltcnt"
			    echo "w_cnt: $w_cnt"
			    ls sult*.txt
			    ls w*.txt
			    echo $sergn > new_combine.txt
			else
			    echo "entry3"
			    echo "sltcnt: $sltcnt"
			    echo "w_cnt: $w_cnt"
			    echo $sergn"_varriant" > new_combine.txt
			fi
		    done
		fi
	    elif [ $sltcnt -lt $w_cnt ]
            then
		zx=`ls sult*.txt | wc -l`
		if [ $nsergn -eq $zx ]
		then
		    echo "entry4"
		    echo "sltcnt: $sltcnt"
		    echo "w_cnt: $w_cnt"
		    ls sult*.txt
		    ls w*.txt
                    echo $sergn"_variiant" > new_combine.txt
		else
                    yx=`grep -L $sergn sult*.txt | wc -l`
		    
                    for (( nyx=1; nyx<=$yx; nyx=$nyx+1 ))
                    do
			xx=`grep -L $sergn sult*.txt | head -$nyx | tail -1 | cut -d "_" -f2 | cut -d "." -f1`
			grep -i $sergn":" output_$xx.out | awk '$3 >= 90.0' > serout_$xx.out
			cp sult_$xx.txt old_sult_$xx.txt
			rm sult_$xx.txt
			
			if [ -s "serout_$xx.out" ]
			then
                            while read -r line || [[ -n $line ]]; do
				a=`echo $line |awk '{print $1}'`
				b=`echo $line |awk '{print $2}'`
				c=`echo $line |awk '{print $3}'`
				d=`echo $line |awk '{print $4}'`
				e=`echo $line |awk '{print $5}'`
				f=`echo $line |awk '{print $6}'`
				g=`echo $line |awk '{print $7}'`
				h=`echo $line |awk '{print $8}'`
				i=`echo $line |awk '{print $9}'`
				j=`echo $line |awk '{print $10}'`
				k=`echo $line |awk '{print $11}'`
				l=`echo $line |awk '{print $12}'`
				m=`echo $line |awk '{printf "%3i", $3}'`
				
				if [ $m -ge 90 ] && [ $d -ge 200 ]; then
                                    p=`echo $b | cut -d "|" -f3 | cut -d ":" -f1`
                                    q=`echo $p | cut -d "_" -f2`
                                    r=`echo $b |cut -d "|" -f4`
                                    if [[ -z "$r" ]]
                                    then
					r=`echo $b | cut -d ":" -f2`
                                    fi
                                    s=`echo $b |cut -d "|" -f2`
                                    echo -e "$q   - $r   - $c   - $d   - $l - $s">>resulvt_$xx.txt
                                    if [ $m -ge 90 ]
                                    then
					echo -e "$q" >> sertp_$xx.txt
				    fi
				else
                                    continue;
				fi
                            done<serout_$xx.out
                            cat sertp_$xx.txt |awk '{print $1}' | sort -k1 -u >> sult_$xx.txt
                            fln=`cat resulvt_$xx.txt |awk '{print $1}' | sort -k1 -u | tr '[:upper:]' '[:lower:]'`
                            cat sertp_$xx.txt |awk '{print $1}' | sort -k1 -u >> $fln.txt
			    
			    echo "entry5"
			    echo "sltcnt: $sltcnt"
			    echo "w_cnt: $w_cnt"
			    ls sult*.txt
			    ls w*.txt
			    echo $sergn"_variaant" > new_combine.txt
			else
			    echo "entry6"
			    echo "sltcnt: $sltcnt"
			    echo "w_cnt: $w_cnt"
			    ls sult*.txt
			    ls w*.txt
                            echo $sergn"_variannt" > new_combine.txt
			fi
                    done
		fi
	    fi
	elif [ $nsergn -eq 3 ]
	then
	    if [ "$sergn" == "k50" ]
	    then
		echo $sergn > new_combine.txt
	    else
		echo "New_Serotype" > new_combine.txt
	    fi
	else
	    echo "New_Serotype" > new_combine.txt
	fi
    else
	echo "New_Serotype" > new_combine.txt
    fi
    #.....
    
    cp resulvt.txt $ncnm"_resulvt.txt"
    prdctn=`cat new_combine.txt | tr "\n\r" ";"`
    wzikag=`cat wzi.txt | tr "\n\r" ";"`
    wzakag=`cat wza.txt | tr "\n\r" ";"`
    wzbkag=`cat wzb.txt | tr "\n\r" ";"`
    wzckag=`cat wzc.txt | tr "\n\r" ";"`
    wzxkag=`cat wzx.txt | tr "\n\r" ";"`
    wzykag=`cat wzy.txt | tr "\n\r" ";"`
    wbapkag=`cat wbap.txt | tr "\n\r" ";"`
    wcajkag=`cat wcaj.txt | tr "\n\r" ";"`
    
    echo -e $ncnm","$wzikag","$wzakag","$wzbkag","$wzckag","$wzxkag","$wzykag","$wbapkag","$wcajkag","$prdctn >> $kppath/Kaptive_var_seq_test.csv 
else
    echo -e $ncnm",NI,NI,NI,NI,NI,NI,NI,NI,NI" >> $kppath/Kaptive_var_seq_test.csv
fi

cat new_combine.txt

mkdir $kppath/$ncnm"_out"
chmod 777 $kppath/$ncnm"_out"
mv *.out $kppath/$ncnm"_out/"
mv *.txt $kppath/$ncnm"_out/"

