#!/bin/bash

n=`cat inpfl.dat | wc -l`
b=$1
c=$2

echo "File,wzi,wza,wzb,wzc,wzx,wzy,wbap,wcaj,K-type" > K_PAM_predict.csv
echo "File,wzm,wzt,wbby,wbbz,O-type" > K_PAM_O_predict.csv
echo "File_name,Virulence,rmpA,rmpA2,iucA,iucB,iucC,iucD,iutA,iroB,iroC,iroD,iroN" > virulence_pred.csv
echo "The virulence genes found in submitted query sequences are as following" > K_PAM_vir_predict.dat

for ((i=1; i<=$n; i++))
do
flnm=`cat inpfl.dat | head -$i | tail -1`
kppath=`echo $flnm | cut -d "." -f1 | rev | cut -d"/" -f2-  | rev`
kpath=$kppath"/"

flxtn=`echo $flnm | rev | cut -d "." -f1 | rev`
if [ $flxtn == "fasta" ]
then
flnm=$flnm
elif [ $flxtn == "fastq" ]
then
#flnm=$kpath
bash cnv_fastq2fasta.sh $flnm
flnmr=`echo $flnm |rev | cut -d "/" -f1 | cut -d "." -f2,3 | rev`
flnm=$flnmr".fasta"
fi

bash k_antgn_testkaptive.sh $flnm $b $c > $flnm"_K_out.txt"
bash o_antgn_testkaptive.sh $flnm $b $c > $flnm"_O_out.txt"

cat Kaptive_var_seq_test.csv >> K_PAM_predict.csv

cat Oaptive_var_seq_test.csv >> K_PAM_O_predict.csv
bash virlprdct.sh $flnm $b $c > $flnm"_vir_out.txt"

done

tr <K_PAM_predict.csv "," " " > K_PAM_predict.dat
tr <K_PAM_O_predict.csv "," " " > K_PAM_O_predict.dat
tr <virulence_pred.csv "," " " > K_PAM_vir_predict.dat

echo "Job completed" > status.txt

rm -rf Kaptive_var_seq_test.csv
rm -rf Oaptive_var_seq_test.csv
