#!/bin/bash

npath=`pwd`
nfile=`eval echo "~$USER/.bashrc"`
echo "******************"
echo "Make sure that only one ncbi-blast tar file is there in the directory."
echo "***************"
tar zxvpf ncbi*.tar.gz
echo $npath
nmncbi=`ls -d ncbi*/ | head -1 | cut -d "/" -f1`
export PATH=$PATH:$npath/$nmncbi/bin/
echo "Installation of all dependencies are completed."
#echo "Type 'blastn -help' to confirm the correct installation of blast+"
blastn -help  
echo "blast is successfuly installed"
n=`grep -i "blast" $nfile|wc -l`
if [ $n -eq 0 ]
   then
   chmod 700 $nfile
   echo $PATH  >> $nfile
fi

m=`grep -i "alias kpam" $nfile|wc -l`
if [ $m -eq 0 ]
   then
   chmod 700 $nfile
   echo "alias kpam='/usr/bin/python  $npath/wx_kpamrun_test5.py' " >> $nfile
fi
echo "All the required installations are done"
echo "**************************"
echo  "Type kpam to get the API"
echo "**************************"
