#!/bin/bash
#formatdb -p F -i gene.fsa
#blastall -p blastn -i some.fasta -d gene.fsa -b 10 -m8 -o output.out
#blastn -query some.fasta -db gene.fsa>align.txt
#echo -e "Target   % Identity Alignment length">>result.txt

tp="MOL"
anu="gene"
echo ""

if [ $tp == "NN" ]
then
    
    if [ $anu == "all" ]
    then
	makeblastdb -in kantgn_gn.fsa -parse_seqids -dbtype nucl #-out dictpp_pt
	formatdb -p F -i kantgn_gn.fsa
	blastn -query some.fasta -db kantgn_gn.fsa -outfmt 6 > output.out
	blastn -query some.fasta -db kantgn_gn.fsa > align.txt
    else

	formatdb -p F -i gene.fsa
	#blastall -p blastn -i some.fasta -d gene.fsa -b 10 -m8 -o output.out
	blastn -query some.fasta -db gene.fsa -outfmt 6 | sort -rnk12 -rnk3 > output.out
	blastn -query some.fasta -db gene.fsa > align.txt
    fi
    
    echo -e "Query,Target (Database sequence),% Identity,Alignment length,No. of mismatches,No. of gap opens,Start position in query,End position in query,Start position in target,End position in target,E-value,Bit-score">result.csv
    gnl=`awk '{print $2}' output.out | cut -d "|" -f2 | sort | uniq | wc -l`

    if [ $gnl -gt 1 ]
    then
        for ((x=1; x<=$gnl; x++))
        do
            gnm=`awk '{print $2}' output.out | cut -d "|" -f2 | sort | uniq | head -$x | tail -1`
            grep -i "|"$gnm"|" output.out > output_$x.out
            y=`wc -l output_$x.out | awk '{print $1}'`
            if [ $y -gt 5 ]
            then
                head -5 output_$x.out > temp.txt
		cat temp.txt > output_$x.out
            fi
            while read -r line || [[ -n $line ]]; do
                a=`echo $line |awk '{print $1}'`
                b=`echo $line |awk '{print $2}'`
                c=`echo $line |awk '{print $3}'`
                d=`echo $line |awk '{print $4}'`
                e=`echo $line |awk '{print $5}'`
                f=`echo $line |awk '{print $6}'`
                g=`echo $line |awk '{print $7}'`
                h=`echo $line |awk '{print $8}'`
                i=`echo $line |awk '{print $9}'`
                j=`echo $line |awk '{print $10}'`
                k=`echo $line |awk '{print $11}'`
                l=`echo $line |awk '{print $12}'`
                m=`echo $line |awk '{printf "%3i", $3}'`
                echo $a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l>>result.csv
                if [ $m -ge 98 ] && [ $d -ge 200 ]; then
                    p=`echo $b | cut -d "|" -f3 | cut -d ":" -f1`
                    q=`echo $p | cut -d "_" -f2`
                    r=`echo $b | cut -d ":" -f2`
                    s=`echo $b | cut -d "|" -f2`
                    echo -e "$q   - $r   - $c   - $d   - $l - $s">>resulvt_$x.txt
                else
                    continue;
                fi
            done<output_$x.out
            cat resulvt_$x.txt |awk '{print $1}' | sort -k1 -u > sult_$x.txt
            grep -i "100.00" resulvt_$x.txt> resulvt_hndrd.txt
            if [ -s "resulvt_hndrd.txt" ];
            then
                awk '{print $1}' resulvt_hndrd.txt | sort -k1 -u> sult_$x.txt
            fi
        done
    else
	while read -r line || [[ -n $line ]]; do
	    a=`echo $line |awk '{print $1}'`
	    b=`echo $line |awk '{print $2}'`
	    c=`echo $line |awk '{print $3}'`
	    d=`echo $line |awk '{print $4}'`
	    e=`echo $line |awk '{print $5}'`
	    f=`echo $line |awk '{print $6}'`
	    g=`echo $line |awk '{print $7}'`
	    h=`echo $line |awk '{print $8}'`
	    i=`echo $line |awk '{print $9}'`
	    j=`echo $line |awk '{print $10}'`
	    k=`echo $line |awk '{print $11}'`
	    l=`echo $line |awk '{print $12}'`
	    m=`echo $line |awk '{printf "%3i", $3}'`
	    echo $a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l>>result.csv
	    if [ $m -ge 98 ] && [ $d -ge 200 ]; then
		p=`echo $b | cut -d "|" -f3 | cut -d ":" -f1`
		q=`echo $p | cut -d "_" -f2`
		r=`echo $b | cut -d ":" -f2`
		s=`echo $b | cut -d "|" -f2`
		echo -e "$q   - $r   - $c   - $d   - $l - $s">>result.txt
		#ab=`cat result.txt |awk '{print $1}'`
		#echo $ab>>col.txt
		#fmt -1 col.txt>>col1.txt
		#sort -k1 -u col1.txt -o result1.txt
	    else
		continue;
	    fi
	done<output.out
	cat result.txt |awk '{print $1}' | sort -k1 -u > result1.txt
	
	grep -i "100.00" result.txt> result_hndrd.txt
	if [ -s "result_hndrd.txt" ];
	then
	    awk '{print $1}' result_hndrd.txt | sort -k1 -u> result1.txt
	fi
    fi
elif [ $tp == "PP" ]
then
    if [ $anu == "wzi" ]
    then
	fseq=`cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'QISAS.*?(?=GYYQQ)'`
	n_lngth=`cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP '.*?(?=QISAS)' | wc -m`
	m_lngth=`cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'QISAS.*?(?=GYYQQ)' | wc -m`
	c_lngth=`cat some.fasta | tail -n +2 | tr -d "\r\n" | sed 's/.*GYYQQ\(.*\)/\1/' | wc -m`

	echo ">n_QISAS" > n_some.fasta
	echo ">m_QISAS_GYYQQ" > m_some.fasta
	echo ">c_GYYQQ" > c_some.fasta

	cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP '.*?(?=QISAS)' >> n_some.fasta
	cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'QISAS.*?(?=GYYQQ)' >> m_some.fasta
	cat some.fasta | tail -n +2 | tr -d "\r\n" | sed 's/.*GYYQQ\(.*\)/\1/' >> c_some.fasta
	
    elif [ $anu == "wzc" ]
    then
	fseq=`cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'SRM.*?(?=SVDL)'`
	n_lngth=`cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP '.*?(?=SRM)' | wc -m`
	m_lngth=`cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'SRM.*?(?=SVDL)' | wc -m`
	c_lngth=`cat some.fasta | tail -n +2 | tr -d "\r\n" | sed 's/.*SVDL\(.*\)/\1/' | wc -m`

	echo ">n_SRM" > n_some.fasta
	echo ">m_SRM_SVDL" > m_some.fasta
	echo ">c_SVDL" > c_some.fasta

	cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP '.*?(?=SRM)' >> n_some.fasta
	cat some.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'SRM.*?(?=SVDL)' >> m_some.fasta
	cat some.fasta | tail -n +2 | tr -d "\r\n" | sed 's/.*SVDL\(.*\)/\1/' >> c_some.fasta
	
    fi

    if [ $anu == "all" ]
    then
	makeblastdb -in kantgn_prot.fasta -dbtype prot -out dictpp_pt
	blastp -db dictpp_pt -query some.fasta -outfmt 6 > output.out
	blastp -db dictpp_pt -query some.fasta -outfmt 0 -out align.txt
    else
	
	makeblastdb -in gene_prot.fasta -dbtype prot -out dict_pt
	blastp -db dict_pt -query some.fasta -outfmt 6 > output.out
	blastp -db dict_pt -query some.fasta -outfmt 0 -out align.txt
    fi
    
	

    echo -e "Query,Target (Database sequence),% Identity,Alignment length,No. of mismatches,No. of gap opens,Start position in query,End position in query,Start position in target,End position in target,E-value,Bit-score">result.csv
    
    while read -r line || [[ -n $line ]]; do
	a=`echo $line |awk '{print $1}'`
	b=`echo $line |awk '{print $2}'`
	c=`echo $line |awk '{print $3}'`
	d=`echo $line |awk '{print $4}'`
	e=`echo $line |awk '{print $5}'`
	f=`echo $line |awk '{print $6}'`
	g=`echo $line |awk '{print $7}'`
	h=`echo $line |awk '{print $8}'`
	i=`echo $line |awk '{print $9}'`
	j=`echo $line |awk '{print $10}'`
	k=`echo $line |awk '{print $11}'`
	l=`echo $line |awk '{print $12}'`
	m=`echo $line |awk '{printf "%3i", $3}'`
	echo $a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l>>result.csv
	if [ $m -ge 98 ] && [ $d -ge 70 ]; then
	    p=`echo $b | cut -d "|" -f3`
	    q=`echo $p | cut -d "_" -f2`
	    r=`echo $b |cut -d "|" -f4`
	    s=`echo $b | cut -d "|" -f2`
	    echo -e "$q   - $r   - $c   - $d   - $l - $s">>result.txt
	    #ab=`cat result.txt |awk '{print $1}'`
	    #echo $ab>>col.txt
	    #fmt -1 col.txt>>col1.txt
	    #sort -k1 -u col1.txt -o result11.txt
	else
	    continue;
	fi
    done<output.out
    cat result.txt |awk '{print $1}' | sort -k1 -u > result11.txt
    
    if [ $anu == "wzi" ]
    then
	
	blastp -db dict_pt -query n_some.fasta -outfmt 6 | sort -rnk3 -rnk12 | head -20 > output_n.out
	blastp -db dict_pt -query n_some.fasta -outfmt 0 -out align2.txt

	echo "n_gene results:" >> result.csv
	while read -r line || [[ -n $line ]]; do
	    a1=`echo $line |awk '{print $1}'`
	    b1=`echo $line |awk '{print $2}'`
	    c1=`echo $line |awk '{print $3}'`
	    d1=`echo $line |awk '{print $4}'`
	    e1=`echo $line |awk '{print $5}'`
	    f1=`echo $line |awk '{print $6}'`
	    g1=`echo $line |awk '{print $7}'`
	    h1=`echo $line |awk '{print $8}'`
	    i1=`echo $line |awk '{print $9}'`
	    j1=`echo $line |awk '{print $10}'`
	    k1=`echo $line |awk '{print $11}'`
	    l1=`echo $line |awk '{print $12}'`
	    m1=`echo $line |awk '{printf "%3i", $3}'`
	    echo $a1,$b1,$c1,$d1,$e1,$f1,$g1,$h1,$i1,$j1,$k1,$l1 >> result.csv
	    if [ $m1 -ge 98 ] && [ $d1 -ge 70 ]; then
		p1=`echo $b1 | cut -d "|" -f3`
		q1=`echo $p1 | cut -d "_" -f2`
		r1=`echo $b1 |cut -d "|" -f4`
		echo -e "$q1   - $r1   - $c1   - $d1   -$l1">> result0.txt
		#ab1=`cat result0.txt |awk '{print $1}'`
		#echo $ab1>>col0.txt
		#fmt -1 col0.txt>>col01.txt
		#sort -k1 -u col01.txt -o result2.txt
	    else
		continue;
	    fi
	done<output_n.out
	cat result0.txt |awk '{print $1}' | sort -k1 -u > result2.txt
    fi
    
    if [ $anu == "wzi" ] || [ $anu == "wzc" ]
    then
	
	blastp -db dict_pt -query m_some.fasta -outfmt 6 | sort -rnk3 -rnk12 | head -20 > output_m.out
	blastp -db dict_pt -query m_some.fasta -outfmt 0 -out align3.txt

	echo "m_gene results:" >> result.csv
	while read -r line || [[ -n $line ]]; do
	    a2=`echo $line |awk '{print $1}'`
	    b2=`echo $line |awk '{print $2}'`
	    c2=`echo $line |awk '{print $3}'`
	    d2=`echo $line |awk '{print $4}'`
	    e2=`echo $line |awk '{print $5}'`
	    f2=`echo $line |awk '{print $6}'`
	    g2=`echo $line |awk '{print $7}'`
	    h2=`echo $line |awk '{print $8}'`
	    i2=`echo $line |awk '{print $9}'`
	    j2=`echo $line |awk '{print $10}'`
	    k2=`echo $line |awk '{print $11}'`
	    l2=`echo $line |awk '{print $12}'`
	    m2=`echo $line |awk '{printf "%3i", $3}'`
	    echo $a2,$b2,$c2,$d2,$e2,$f2,$g2,$h2,$i2,$j2,$k2,$l2 >> result.csv
	    if [ $m2 -ge 98 ] && [ $d2 -ge 70 ]; then
		p2=`echo $b2 | cut -d "|" -f3`
		q2=`echo $p2 | cut -d "_" -f2`
		r2=`echo $b2 |cut -d "|" -f4`
		echo -e "$q2   - $r2  - $c2   - $d2   - $l2">> result00.txt
		#ab2=`cat result00.txt |awk '{print $1}'`
		#echo $ab2>>col00.txt
		#fmt -1 col00.txt>>col001.txt
		#sort -k1 -u col001.txt -o result3.txt
	    else
		continue;
	    fi
	done<output_m.out
	cat result00.txt |awk '{print $1}' | sort -k1 -u > result3.txt
    fi

    if [ $anu == "wzi" ]
    then
	
	blastp -db dict_pt -query c_some.fasta -outfmt 6 | sort -rnk3 -rnk12 | head -20 > output_c.out
	blastp -db dict_pt -query c_some.fasta -outfmt 0 -out align4.txt

	echo "c_gene results:" >> result.csv
	while read -r line || [[ -n $line ]]; do
	    a3=`echo $line |awk '{print $1}'`
	    b3=`echo $line |awk '{print $2}'`
	    c3=`echo $line |awk '{print $3}'`
	    d3=`echo $line |awk '{print $4}'`
	    e3=`echo $line |awk '{print $5}'`
	    f3=`echo $line |awk '{print $6}'`
	    g3=`echo $line |awk '{print $7}'`
	    h3=`echo $line |awk '{print $8}'`
	    i3=`echo $line |awk '{print $9}'`
	    j3=`echo $line |awk '{print $10}'`
	    k3=`echo $line |awk '{print $11}'`
	    l3=`echo $line |awk '{print $12}'`
	    m3=`echo $line |awk '{printf "%3i", $3}'`
	    echo $a3,$b3,$c3,$d3,$e3,$f3,$g3,$h3,$i3,$j3,$k3,$l3 >> result.csv
	    if [ $m3 -ge 98 ] && [ $d3 -ge 70 ]; then
		p3=`echo $b3 | cut -d "|" -f3`
		q3=`echo $p3 | cut -d "_" -f2`
		r3=`echo $b3 |cut -d "|" -f4`
		echo -e "$q3   - $r3   - $c3   - $d3   - $l3">>result000.txt
		
		#ab3=`cat result000.txt |awk '{print $1}'`
		#echo $ab3>>col000.txt
		#fmt -1 col000.txt>>col0001.txt
		#sort -k1 -u col0001.txt -o result4.txt
	    else
		continue;
	    fi
	done<output_c.out
	cat result000.txt |awk '{print $1}' | sort -k1 -u > result4.txt
    fi
    
    if [ $anu == "wzi" ]
    then
	comm -12 result11.txt result3.txt > resx.txt
	comm -12 result2.txt result4.txt > resy.txt
	comm -12 resx.txt resy.txt > result1.txt
	
    elif [ $anu == "wzc" ]
    then
	comm -12 result11.txt result3.txt > result1.txt

    else
	cat result11.txt > result1.txt
    fi

    grep -i "100.00" result.txt > result_hndrd.txt
    if [ -s "result_hndrd.txt" ];
    then
	awk '{print $1}' result_hndrd.txt | sort -k1 -u > result1.txt
    fi
    
        
elif [ $tp == "NP" ]
then

    cat some.fasta | head -1 | tr -d "\r\n" > newp.fasta
    
    cp /var/www/K-PAM/python/trnsltn_gn.py .
    cat some.fasta | tail -n +2 | tr -d "\r\n" > tnew.txt    
    python trnsltn_gn.py >> newp.fasta
    
    if [ $anu == "wzi" ]
    then
	fseq=`cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'QISAS.*?(?=GYYQQ)'`
	n_lngth=`cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP '.*?(?=QISAS)' | wc -m`
	m_lngth=`cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'QISAS.*?(?=GYYQQ)' | wc -m`
	c_lngth=`cat newp.fasta | tail -n +2 | tr -d "\r\n" | sed 's/.*GYYQQ\(.*\)/\1/' | wc -m`

	echo ">n_QISAS" > n_some.fasta
	echo ">m_QISAS_GYYQQ" > m_some.fasta
	echo "c_GYYQQ" > c_some.fasta

	cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP '.*?(?=QISAS)' >> n_some.fasta
	cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'QISAS.*?(?=GYYQQ)' >> m_some.fasta
	cat newp.fasta | tail -n +2 | tr -d "\r\n" | sed 's/.*GYYQQ\(.*\)/\1/' >> c_some.fasta

    elif [ $anu == "wzc" ]
    then
	fseq=`cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'SRM.*?(?=SVDL)'`
	n_lngth=`cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP '.*?(?=SRM)' | wc -m`
	m_lngth=`cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'SRM.*?(?=SVDL)' | wc -m`
	c_lngth=`cat newp.fasta | tail -n +2 | tr -d "\r\n" | sed 's/.*SVDL\(.*\)/\1/' | wc -m`

	echo ">n_SRM" > n_some.fasta
	echo ">m_SRM_SVDL" > m_some.fasta
	echo "c_SVDL" > c_some.fasta

	cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP '.*?(?=SRM)' >> n_some.fasta
	cat newp.fasta | tail -n +2 | tr -d "\r\n" | grep -oP 'SRM.*?(?=SVDL)' >> m_some.fasta
	cat newp.fasta | tail -n +2 | tr -d "\r\n" | sed 's/.*SVDL\(.*\)/\1/' >> c_some.fasta

    fi

    if [ $anu == "all" ]
    then
        makeblastdb -in kantgn_prot.fasta -dbtype prot -out dictpp_pt
        blastp -db dictpp_pt -query newp.fasta -outfmt 6 > output.out
        blastp -db dictpp_pt -query newp.fasta -outfmt 0 -out align.txt
    else
	
        makeblastdb -in gene_prot.fasta -dbtype prot -out dict_pt
        blastp -db dict_pt -query newp.fasta -outfmt 6 > output.out
        blastp -db dict_pt -query newp.fasta -outfmt 0 -out align.txt
    fi

    echo -e "Query,Target (Database sequence),% Identity,Alignment length,No. of mismatches,No. of gap opens,Start position in query,End position in query,Start position in target,End position in target,E-value,Bit-score">result.csv

    while read -r line || [[ -n $line ]]; do
	a=`echo $line |awk '{print $1}'`
	b=`echo $line |awk '{print $2}'`
	c=`echo $line |awk '{print $3}'`
	d=`echo $line |awk '{print $4}'`
	e=`echo $line |awk '{print $5}'`
	f=`echo $line |awk '{print $6}'`
	g=`echo $line |awk '{print $7}'`
	h=`echo $line |awk '{print $8}'`
	i=`echo $line |awk '{print $9}'`
	j=`echo $line |awk '{print $10}'`
	k=`echo $line |awk '{print $11}'`
	l=`echo $line |awk '{print $12}'`
	m=`echo $line |awk '{printf "%3i", $3}'`
	echo $a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l>>result.csv
	if [ $m -ge 98 ] && [ $d -ge 70 ]; then
	    p=`echo $b | cut -d "|" -f2`
	    q=`echo $p | cut -d "_" -f2`
	    r=`echo $b |cut -d "|" -f3`
	    echo -e "$q   - $r   - $c   - $d   - $l">>result.txt
	    #ab=`cat result.txt |awk '{print $1}'`
	    #echo $ab>>col.txt
	    #fmt -1 col.txt>>col1.txt
	    #sort -k1 -u col1.txt -o result11.txt
	else
	    continue;
	fi
    done<output.out
    cat result.txt |awk '{print $1}' | sort -k1 -u > result11.txt

    if [ $anu == "wzi" ]
    then
	
	blastp -db dict_pt -query n_some.fasta -outfmt 6 | sort -rnk12 -rnk3 > output_n.out
	blastp -db dict_pt -query n_some.fasta -outfmt 0 -out align2.txt
    
	echo "n_gene results:" >> result.csv
	while read -r line || [[ -n $line ]]; do
	    a1=`echo $line |awk '{print $1}'`
	    b1=`echo $line |awk '{print $2}'`
	    c1=`echo $line |awk '{print $3}'`
	    d1=`echo $line |awk '{print $4}'`
	    e1=`echo $line |awk '{print $5}'`
	    f1=`echo $line |awk '{print $6}'`
	    g1=`echo $line |awk '{print $7}'`
	    h1=`echo $line |awk '{print $8}'`
	    i1=`echo $line |awk '{print $9}'`
	    j1=`echo $line |awk '{print $10}'`
	    k1=`echo $line |awk '{print $11}'`
	    l1=`echo $line |awk '{print $12}'`
	    m1=`echo $line |awk '{printf "%3i", $3}'`
	    echo $a1,$b1,$c1,$d1,$e1,$f1,$g1,$h1,$i1,$j1,$k1,$l1 >> result.csv
	    if [ $m1 -ge 98 ] && [ $d1 -ge 70 ]; then
		p1=`echo $b1 | cut -d "|" -f2`
		q1=`echo $p1 | cut -d "_" -f2`
		r1=`echo $b1 |cut -d "|" -f3`
		echo -e "$q1   - $r1   - $c1   - $d1   - $l1">>result0.txt
		
		#ab1=`cat result0.txt |awk '{print $1}'`
		#echo $ab1>>col0.txt
		#fmt -1 col0.txt>>col01.txt
		#sort -k1 -u col01.txt -o result2.txt
	    else
		continue;
	    fi
	done<output_n.out
	cat result0.txt |awk '{print $1}' | sort -k1 -u > result2.txt

    fi

    if [ $anu == "wzi" ] || [ $anu == "wzc" ]
    then
	
	blastp -db dict_pt -query m_some.fasta -outfmt 6 | sort -rnk12 -rnk3 > output_m.out
	blastp -db dict_pt -query m_some.fasta -outfmt 0 -out align3.txt
    
	echo "m_gene results:" >> result.csv
	while read -r line || [[ -n $line ]]; do
	    a2=`echo $line |awk '{print $1}'`
	    b2=`echo $line |awk '{print $2}'`
	    c2=`echo $line |awk '{print $3}'`
	    d2=`echo $line |awk '{print $4}'`
	    e2=`echo $line |awk '{print $5}'`
	    f2=`echo $line |awk '{print $6}'`
	    g2=`echo $line |awk '{print $7}'`
	    h2=`echo $line |awk '{print $8}'`
	    i2=`echo $line |awk '{print $9}'`
	    j2=`echo $line |awk '{print $10}'`
	    k2=`echo $line |awk '{print $11}'`
	    l2=`echo $line |awk '{print $12}'`
	    m2=`echo $line |awk '{printf "%3i", $3}'`
	    echo $a2,$b2,$c2,$d2,$e2,$f2,$g2,$h2,$i2,$j2,$k2,$l2 >> result.csv
	    if [ $m2 -ge 98 ] && [ $d2 -ge 70 ]; then
		p2=`echo $b2 | cut -d "|" -f2`
		q2=`echo $p2 | cut -d "_" -f2`
		r2=`echo $b2 |cut -d "|" -f3`
		echo -e "$q2  - $r2   - $c2   - $d2   - $l2" >> result00.txt
		
		#ab2=`cat result00.txt |awk '{print $1}'`
		#echo $ab2>>col00.txt
		#fmt -1 col00.txt>>col001.txt
		#sort -k1 -u col001.txt -o result3.txt
	    else
		continue;
	    fi
	done<output_m.out
	cat result00.txt |awk '{print $1}' | sort -k1 -u > result3.txt
    fi

    if [ $anu == "wzi" ]
    then
	
	blastp -db dict_pt -query c_some.fasta -outfmt 6 | sort -rnk12 -rnk3 > output_c.out
	blastp -db dict_pt -query c_some.fasta -outfmt 0 -out align4.txt
	
	echo "c_gene results:" >> result.csv
	while read -r line || [[ -n $line ]]; do
	    a3=`echo $line |awk '{print $1}'`
	    b3=`echo $line |awk '{print $2}'`
	    c3=`echo $line |awk '{print $3}'`
	    d3=`echo $line |awk '{print $4}'`
	    e3=`echo $line |awk '{print $5}'`
	    f3=`echo $line |awk '{print $6}'`
	    g3=`echo $line |awk '{print $7}'`
	    h3=`echo $line |awk '{print $8}'`
	    i3=`echo $line |awk '{print $9}'`
	    j3=`echo $line |awk '{print $10}'`
	    k3=`echo $line |awk '{print $11}'`
	    l3=`echo $line |awk '{print $12}'`
	    m3=`echo $line |awk '{printf "%3i", $3}'`
	    echo $a3,$b3,$c3,$d3,$e3,$f3,$g3,$h3,$i3,$j3,$k3,$l3 >> result.csv
	    if [ $m3 -ge 98 ] && [ $d3 -ge 70 ]; then
		p3=`echo $b3 | cut -d "|" -f2`
		q3=`echo $p3 | cut -d "_" -f2`
		r3=`echo $b3 |cut -d "|" -f3`
		echo -e "$q3  - $r3   - $c3   - $d3   - $l3">>result000.txt
		
		#ab3=`cat result000.txt |awk '{print $1}'`
		#echo $ab3>>col000.txt
		#fmt -1 col000.txt>>col0001.txt
		#sort -k1 -u col0001.txt -o result4.txt
	    else
		continue;
	    fi
	done<output_c.out
	cat result000.txt |awk '{print $1}' | sort -k1 -u > result4.txt
    fi

    if [ $anu == "wzi" ]
    then
        comm -12 result11.txt result3.txt > resx.txt
	comm -12 result2.txt result4.txt > resy.txt
	comm -12 resx.txt resy.txt > result1.txt
    elif [ $anu == "wzc" ]
    then
	comm -12 result11.txt result3.txt > result1.txt

    else
	cat result11.txt > result1.txt
    fi
    grep -i "100.00" result.txt> result_hndrd.txt
    if [ -s "result_hndrd.txt" ];
    then
	awk '{print $1}' result_hndrd.txt | sort -k1 -u> result1.txt
    fi
fi

